#version 430 core

uniform vec3 lightDir;
uniform vec3 color1;
uniform vec3 color2;

in vec3 interpNormal;
in vec3 interpWorldPos;

void main()
{
	vec3 normal = normalize(interpNormal);
	float diffuse = max(dot(normal, -lightDir), 0.0);
	
	//float t = sin(20.0 * interpWorldPos.y);
	//vec3 color = t > 0.0 ? color1 : color2;
	
	float t = sin(20.0 * interpWorldPos.y) * 0.5 + 0.5;
	vec3 color = mix(color1, color2, t);
	
	gl_FragColor = vec4(color * diffuse, 1.0);
}
