#version 430 core

uniform vec3 lightDir;
uniform vec3 cameraPos;


uniform sampler2D colorTexture;
uniform sampler2D normalMap;


in vec3 interpNormal;
in vec2 interpTexCoord;
in vec3 interpPosition;
in vec3 lightVec;
in vec3 eyeVec;
in vec3 tang;

void main()
{
	//vec3 normal = normalize(interpNormal);
	//lightDir = lightVec;
	vec3 normal = normalize(2.0 * texture2D (normalMap, interpTexCoord.st).rgb - 1.0);
	//vec3 toEye = normalize(cameraPos - interpPosition);
	vec3 toEye = normalize(tang - eyeVec);
	float diffuse = max(dot(normal, -normalize(lightVec)), 0.0);
	float specular = pow(max(dot(toEye, reflect(lightVec, normal)), 0.0), 30.0);

	gl_FragColor = vec4(texture2D(colorTexture, interpTexCoord).rgb * diffuse + vec3(1.0) * specular, 1.0);
	//gl_FragColor =  vec4(tang, 1.0);
}
