#version 430 core

layout(location = 0) in vec3 vertexPosition;
layout(location = 1) in vec2 vertexTexCoord;
layout(location = 2) in vec3 vertexNormal;
layout(location = 3) in vec3 vertexTangent;

uniform vec3 lightDir;
uniform vec3 cameraPos;

uniform mat4 modelViewProjectionMatrix;
uniform mat4 modelViewMatrix;
uniform mat4 modelMatrix;

out vec3 interpNormal;
out vec2 interpTexCoord;
out vec3 interpPosition;
out vec3 lightVec;
out vec3 eyeVec;
out vec3 tang;

void main()
{
	gl_Position = modelViewProjectionMatrix * vec4(vertexPosition, 1.0);
	interpNormal = (modelMatrix * vec4(vertexNormal, 0.0)).xyz;
	interpTexCoord = vec2(vertexTexCoord.x, 1.0 - vertexTexCoord.y);
	interpPosition = (modelMatrix * vec4(vertexPosition, 1.0)).xyz;

	vec3 n = normalize ((modelMatrix * normalize(vec4(vertexNormal, 0.0))).xyz);
	vec3 t = normalize ((modelMatrix * normalize(vec4(vertexTangent, 0.0))).xyz);
	vec3 b = normalize(cross (t, n));


	vec3 viewPos = (modelViewMatrix * vec4(vertexPosition, 1.0)).xyz;
		
		
	// transform light and half angle vectors by tangent basis
	vec3 v;
	v.x = dot (lightDir, t);
	v.y = dot (lightDir, b);
	v.z = dot (lightDir, n);
	lightVec = normalize (v);
	
	  
	v.x = dot (interpPosition, t);
	v.y = dot (interpPosition, b);
	v.z = dot (interpPosition, n);
	eyeVec =  (v);

	v.x = dot (cameraPos, t);
	v.y = dot (cameraPos, b);
	v.z = dot (cameraPos, n);
	tang =  (v);

	//tang =  vertexTangent;
}
