#pragma once

#include "glm.hpp"

namespace Core
{

	const float frustumScale = 1.1f;
	
	glm::mat4 createPerspectiveMatrix(float zNear = 0.1f, float zFar = 100.0f, int h=600, int w=600);

	// position - pozycja kamery
	// forward - wektor "do przodu" kamery (jednostkowy)
	// up - wektor "w gore" kamery (jednostkowy)
	// up i forward musza byc ortogonalne!
	glm::mat4 createViewMatrix(glm::vec3 position, glm::vec3 forward, glm::vec3 up);


	void reshape(int w, int h);
}